// Single-sum checksum examples -- Chapter 6 header

// Copyright 2024 Philip Koopman
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//    http://www.apache.org/licenses/LICENSE-2.0
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

#include <inttypes.h>
#include <assert.h>

#ifndef SEED    // Compiler constant for initial seed
#define SEED 0x9D
#endif

uint32_t DualSum16_A(uint8_t dataWord[],
                     uint32_t dwSize, uint32_t modulus);

uint32_t DualSum16_B(uint8_t dataWord[],
                     uint32_t dwSize, uint32_t modulus); 

uint32_t DualSum16_C(uint8_t dataWord[],
                     uint32_t dwSize, uint32_t modulus);

uint32_t DualSum16_D(uint8_t dataWord[],
                     uint32_t dwSize, uint32_t modulus);
                     
uint32_t DualSum16_E(uint8_t dataWord[],
                     uint32_t dwSize, uint32_t modulus);
                     
uint32_t Fletcher16(uint8_t dataWord[],
                    uint32_t dwSize, uint32_t modulus);
                                                             
uint32_t DualX(uint8_t dataWord[],
                    uint32_t dwSize, uint32_t modulus);
