// Checksum & CRC Support code  / header file

// Copyright 2024 Philip Koopman
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//    http://www.apache.org/licenses/LICENSE-2.0
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

#include <stdio.h>
#include <stdlib.h>
#include <inttypes.h>
#include <time.h>
#include <assert.h>
#include <stdbool.h>

// Compiling:  #define VALIDATION to use fixed data word values
//    else uses random data word values
// For validation, data word length is at most 9

// Initialize data word with validation string or pseudorandom data
void InitializeData(uint8_t codeWord[], uint32_t cwLen);
void InitializeData16(uint8_t codeWord[], uint32_t cwLen, uint16_t codeWordW[], uint32_t cwLenW);

// Print current code word or data word value as a sequence of bytes
void PrintWord(uint8_t word[], uint32_t len);
void PrintWord16(uint16_t wordW[], uint32_t lenW);



